﻿using System.Collections.Generic;

namespace GenericsUsing
{
    // msdn.microsoft.com/en-us/library/0x6a29h6.aspx 
    public class GenericList<T>
    {
        // The nested class is also generic on T. 
        private class Node
        {
            // T used in non-generic constructor. 
            public Node(T t)
            {
                Next = null;
                Data = t;
            }

            public Node Next { get; set; }

            // T as private member data type. 

            // T as return type of property. 
            public T Data { get; set; }
        }

        private Node _head;

        // constructor 
        public GenericList()
        {
            _head = null;
        }

        // T as method parameter type: 
        public void AddHead(T t)
        {
            Node n = new Node(t);
            n.Next = _head;
            _head = n;
        }

        public IEnumerator<T> GetEnumerator()
        {
            Node current = _head;

            while (current != null)
            {
                yield return current.Data;
                current = current.Next;
            }
        }
    }
}
